public class SelectionSortWithTiming
{
	 public static int smallestInRange(double[] data,
						      int lo, int hi)
	    {
			int iSmallest = lo;
	        for (int i=lo; i<=hi; i++)
				if (data[i] < data[iSmallest])
					iSmallest = i;
			return iSmallest;
	    }


    public static void selectionSort(double[] data)
    {
		/* Note the bounds - why don't go all the way to data.length - 1 ? */
        for (int i=0; i<data.length-1; i++)
		{
		    int iSmallest = smallestInRange(data,i,data.length-1);

		    /* Swap values */
            double temp = data[i];
            data[i] = data[iSmallest];
            data[iSmallest] = temp;
		}
    }


	public static void fillArray(double[] data)
	{
		for (int i = 0; i < data.length; i++)
			data[i] = Math.random() * 1000.0;
	}


	public static void testSort(int size)
	{
		double[] data = new double[size];
		long deltaT;


		fillArray(data);


		//Date d1 = new Date();
		StopWatch watch = new StopWatch();
		//Timer t = new Timer();
		//t.start();
		watch.start();
		selectionSort(data);
		watch.stop();
		//t.stop();
		//Date d2 = new Date();
		//deltaT = d2.getTime() - d1.getTime();
		//System.out.println("Size : " + size + " Time (msecs) : " + deltaT);
		System.out.println("Size : " + size + " Time (msecs) : " + 
							watch.getElapsedTime());
	}


    public static void main(String[] args)
    {
		testSort(10000);
		testSort(20000);
		testSort(40000);
		testSort(100000);

    }
}
